clc;clear all;pack;clear global;close all;
cartella_base = '';
% "entry_id","user","word_id"
% Ex. 1265691732,"76939bcf1ff4e987575d946bfd0831",1
file = textread(strcat(cartella_base,'KSP-Entry.csv'),'%s','delimiter','\n');
file = file(2:end);
Lf   = length(file);
EntryId_User_WordId = [];
for k=1:Lf
    riga = file{k};
    pos  = strfind(riga,',');
    EntryId = riga(1:pos(1)-1);
    EntryId_User_WordId{k,1} = EntryId;
    User = riga(pos(1)+2:pos(2)-2);
    EntryId_User_WordId{k,2} = User;
    WordId = str2num(riga(pos(2)+1:end));
    EntryId_User_WordId{k,3} = WordId;
end
% entry_id,start,stop,key_char
% Ex. 1265691729,0,45,p
file = textread(strcat(cartella_base,'KSP-KeyPress.csv'),'%s','delimiter','\n');
file = file(2:end);
Lf   = length(file);
EntryId_Start_Stop_KeyChar = [];
for k=1:Lf
    riga = file{k};
    pos  = strfind(riga,',');
    EntryId = riga(1:pos(1)-1);
    EntryId_Start_Stop_KeyChar{k,1} = EntryId;
    Start = str2num(riga(pos(1)+1:pos(2)-1));
    EntryId_Start_Stop_KeyChar{k,2} = Start;
    Stop = str2num(riga(pos(2)+1:pos(3)-1));
    EntryId_Start_Stop_KeyChar{k,3} = Stop;
    KeyChar = riga(pos(3)+1:end);
    EntryId_Start_Stop_KeyChar{k,4} = KeyChar;
end
% email,name
% Ex. 03ade935124045f075c2e401f9e378,
file = textread(strcat(cartella_base,'KSP-User.csv'),'%s','delimiter','\n');
file = file(2:end);
Lf   = length(file);
Email_Name = [];
for k=1:Lf
    riga = file{k};
    pos  = strfind(riga,',');
    Email = riga(1:pos(1)-1);
    Email_Name{k,1} = Email;
    Name = riga(pos(1)+1:end);
    Email_Name{k,2} = Name;
end
% word,word_id
% Ex. drizzle,0
file = textread(strcat(cartella_base,'KSP-Word.csv'),'%s','delimiter','\n');
file = file(2:end);
Lf   = length(file);
Word_WordId = [];
for k=1:Lf
    riga = file{k};
    pos  = strfind(riga,',');
    Word = riga(1:pos(1)-1);
    Word_WordId{k,1} = Word;
    WordId = str2num(riga(pos(1)+1:end));
    Word_WordId{k,2} = WordId;
end
%--------------------------------------------------------------------------
% Selection of keyword that will be used for training and testing
passord_list{1} = 'drizzle';
passord_list{2} = 'jeffrey allen';
passord_list{3} = 'pr7q1z';

for selected_keyword=0:2
    keyword_list = zeros(size(EntryId_User_WordId,1),1);
    for k=1:size(EntryId_User_WordId,1)
        keyword_list(k) = EntryId_User_WordId{k,3};
    end
    pos_keywords = find(keyword_list==selected_keyword);

    selected_EntryId = EntryId_User_WordId(pos_keywords,1);
    selected_User    = EntryId_User_WordId(pos_keywords,2);
    selected_WordId  = EntryId_User_WordId(pos_keywords,3);

    selected_UserNo = zeros(length(selected_User),1);
    for ii=1:length(selected_User)
        current_user = selected_User{ii};
        for jj=1:size(Email_Name,1)
            db_user = Email_Name{jj,1};
            if strcmp(current_user,db_user)
                selected_UserNo(ii) = jj;
                break;
            end
        end
    end
    EntryId_Vector = zeros(size(EntryId_Start_Stop_KeyChar,1),1);
    for k=1:size(EntryId_Start_Stop_KeyChar,1)
        EntryId_Vector(k) = str2num(EntryId_Start_Stop_KeyChar{k,1});
    end

    current_EntryId = str2num(selected_EntryId{1});
    pos = find(EntryId_Vector==current_EntryId);
    StartTime = zeros(length(selected_EntryId),length(pos));
    StopTime  = zeros(length(selected_EntryId),length(pos));

    for ii=1:length(selected_EntryId)
        current_EntryId = str2num(selected_EntryId{ii});
        pos = find(EntryId_Vector==current_EntryId);
        %disp(EntryId_Start_Stop_KeyChar(pos,4)');
        %pause;
        for jj=1:length(pos)
            StartTime(ii,jj) = EntryId_Start_Stop_KeyChar{pos(jj),2};
            StopTime(ii,jj)  = EntryId_Start_Stop_KeyChar{pos(jj),3};
        end
    end
    % StartTime and StopTime are matrices with start and stop time of each char
    % for the selected keyword. selected_UserNo is a vector with person ID.
    % selected_EntryId: list of entry id for selected password
    % selected_UserNo:  list of user for selected password
    % StartTime:        matrix of start time
    % StopTime:         matrix of stop time
    

    L = length(selected_EntryId);
    start_vector   = StartTime(1,:);
    stop_vector    = StopTime(1,:);
    
    user_count = zeros(max(selected_UserNo),1);
    for k=1:L
        disp(k/L);
        start_vector = StartTime(k,:);
        stop_vector  = StopTime(k,:);

        user_id = selected_UserNo(k);

        user_count(user_id) = user_count(user_id)+1;

        stringanome = strcat(passord_list{selected_keyword+1},'_','user',num2str(user_id),'_',num2str(user_count(user_id)),'.txt');

        fid = fopen(stringanome,'w');
        fprintf(fid,'%s\n%s',num2str(start_vector),num2str(stop_vector));
        fclose(fid);

        pause(0.32);
    end
end
